diff --git a/client/tests/kvm/steps/WinVista-32-rss.steps b/client/tests/kvm/steps/WinVista-32-rss.steps
index 643f52e..8d0aa4d 100644
--- a/client/tests/kvm/steps/WinVista-32-rss.steps
+++ b/client/tests/kvm/steps/WinVista-32-rss.steps
@@ -1,22 +1,29 @@
 # Generated by Step Maker
-# Generated on Sun Aug  9 04:19:57 2009
+# Generated on Tue Nov  3 14:17:33 2009
 # uname -a: Linux dhcp-1-188.tlv.redhat.com 2.6.18-128.1.1.el5 #1 SMP Mon Jan 26 13:58:24 EST 2009 x86_64 x86_64 x86_64 GNU/Linux
 # --------------------------------
-step 71.65
-screendump 20090809_042109_8c9fa395fde6d45736fe5e78ebad061e.ppm
-# reached desktop; open start menu
-barrier_2 78 30 358 234 d864236c59edceb198409f034b61aa0e 358
-# Sending keys: ctrl-esc
-key ctrl-esc
+step 87.91
+screendump 20091103_141901_8a894eeeb57395c0c148677922cfe404.ppm
+# Reached welcome screen
+barrier_2 82 26 336 249 695dc13173329b155e7ec6f7051ec59e 440
+# Sending keys: 0xdc-r
+key 0xdc-r
 # --------------------------------
-step 76.05
-screendump 20090809_042139_c3155a2c89fcd79dc61478af560ed357.ppm
-# run "d:\setuprss"
-barrier_2 50 13 28 545 42dcbd7b221f12845583f08fb6dbbc66 21
-# Sending keys: d shift-0x27 0x2b s e t u p r s s
+step 92.37
+screendump 20091103_141944_86b166a4d5d978c271b2d27015032738.ppm
+# Open d:\ in a file browser
+barrier_2 36 59 225 428 2ceabcaf10d637b6f6c82309d70972a1 21
+# Sending keys: d shift-0x27 0x2b ret
 key d
 key shift-0x27
 key 0x2b
+key ret
+# --------------------------------
+step 97.15
+screendump 20091103_142130_1136501f2ac6c8a1e8bcabda42b34126.ppm
+# Select setuprss.bat
+barrier_2 86 20 170 468 cf5e40c2969c78d266c3d05aacd628c5 19
+# Sending keys: s e t u p r s s menu
 key s
 key e
 key t
@@ -25,30 +32,22 @@ key p
 key r
 key s
 key s
-# --------------------------------
-step 83.19
-screendump 20090809_042249_46f97eb05a2aabfc918fed642038c03a.ppm
-barrier_2 18 25 14 12 0f48ac3d9a2c1d88d0519721129ce8bf 23
-# Sending keys: down menu
-key down
 key menu
 # --------------------------------
-step 88.52
-screendump 20090809_042324_0eac577fff261097eb35e8a3e41b11ba.ppm
-# run as administrator
-barrier_2 21 58 128 138 9d6d14c39767166f2dd54b644b4430a3 24
+step 103.84
+screendump 20091103_142159_45c9e2fe113811477bba4408c6abb96e.ppm
+# Run as administrator
+sleep 15
 # Sending keys: a
 key a
 # --------------------------------
-step 93.15
-screendump 20090809_042342_0abaf4bb1d04389c5b4548dc031989ca.ppm
-# continue
-barrier_2 20 44 248 239 522013a7f99ea1a1dfbb4a4d5c61dd2a 90
+step 108.32
+screendump 20091103_142215_419d87101ea2204c7eb2f7a997b4792a.ppm
+# Continue
+barrier_2 31 42 462 316 52bc2803827bd4b931bc44a693f81763 90
 # Sending keys: alt-c
 key alt-c
 # --------------------------------
-step 102.84
-screendump 20090809_042403_e287c85ba9d66dd09412917bfc1fecb5.ppm
-# make sure we're done
+step 116.77
+screendump 20091103_142350_c002f223bec9032582be98c095440550.ppm
 sleep 20
-barrier_2 87 25 353 387 4335934bbb63865c37aa2aa6c2376440 90
diff --git a/client/tests/kvm/steps/WinVista-64-rss.steps b/client/tests/kvm/steps/WinVista-64-rss.steps
index 611a420..51cd03e 100644
--- a/client/tests/kvm/steps/WinVista-64-rss.steps
+++ b/client/tests/kvm/steps/WinVista-64-rss.steps
@@ -1,22 +1,29 @@
 # Generated by Step Maker
-# Generated on Sun Aug  9 03:27:16 2009
+# Generated on Tue Nov  3 12:54:21 2009
 # uname -a: Linux dhcp-1-188.tlv.redhat.com 2.6.18-128.1.1.el5 #1 SMP Mon Jan 26 13:58:24 EST 2009 x86_64 x86_64 x86_64 GNU/Linux
 # --------------------------------
-step 78.22
-screendump 20090809_032834_6adc21f17f854751b7c5ef6814afe4be.ppm
-# reached desktop; open start menu
-barrier_2 109 32 319 245 e40688e5ea8acae0068bf32ae0882d66 391
-# Sending keys: ctrl-esc
-key ctrl-esc
+step 66.30
+screendump 20091103_125527_8c5790d596d390e608546b8fde43723a.ppm
+# Reached welcome screen
+barrier_2 105 26 323 248 372eed00e7cf592abd9449ab9a206805 332
+# Sending keys: 0xdc-r
+key 0xdc-r
 # --------------------------------
-step 83.61
-screendump 20090809_033130_129378458c3edb1ef199ba8dbb6450fa.ppm
-# run "d:\setuprss"
-barrier_2 56 16 26 543 92e2726e7aa3de5bda7cb0448729e569 26
-# Sending keys: d shift-0x27 0x2b s e t u p r s s
+step 72.79
+screendump 20091103_125556_a0481b7af349009d81956062e1027060.ppm
+# Open d:\ in a file browser
+barrier_2 31 60 234 429 7b73df710244d1da8442869ff838d202 31
+# Sending keys: d shift-0x27 0x2b ret
 key d
 key shift-0x27
 key 0x2b
+key ret
+# --------------------------------
+step 78.94
+screendump 20091103_125716_65a3f5e9b42d3abec7df1614a676230f.ppm
+# Select setuprss.bat
+barrier_2 47 19 172 468 1f4ad0e4e2d2226e9c3f0f71a847bf92 26
+# Sending keys: s e t u p r s s menu
 key s
 key e
 key t
@@ -25,30 +32,22 @@ key p
 key r
 key s
 key s
-# --------------------------------
-step 90.03
-screendump 20090809_033308_427a6436d2d53bc48a550d6e9d51ea30.ppm
-barrier_2 17 23 14 12 1ee0bb3e04af4ae9cad6ea4d7e60ee0c 20
-# Sending keys: down menu
-key down
 key menu
 # --------------------------------
-step 93.51
-screendump 20090809_033402_35adbe6265a33ea3e710bc6c345ddeb4.ppm
-# run as administrator
-barrier_2 24 63 128 138 f1048184cda8600c51d6b4c8c272d60f 15
+step 85.08
+screendump 20091103_130006_6f30a7856188691661ea1d1aa39ddf29.ppm
+# Run as administrator
+sleep 15
 # Sending keys: a
 key a
 # --------------------------------
-step 99.21
-screendump 20090809_033431_30cfd66164171798c723f1ebd9d2dd63.ppm
-# continue
-barrier_2 30 45 240 239 a99732ded3422fa552a5eebd19104bf1 90
+step 90.72
+screendump 20091103_130053_355335e40dcdb7858a99144e0847d8a3.ppm
+# Continue
+barrier_2 36 40 468 317 53db55cefd8f209788aea1f3221a6339 90
 # Sending keys: alt-c
 key alt-c
 # --------------------------------
-step 110.47
-screendump 20090809_033505_56d081cf5ec82e94c86341cfe782f982.ppm
-# done
+step 103.87
+screendump 20091103_130135_4b39cf719107dfc4c2ba0be47c200640.ppm
 sleep 20
-barrier_2 102 30 328 387 989a51cb302891c8a0a1ff5cc9a528be 90